import 'dart:io';

import 'package:firebase_core/firebase_core.dart';
import 'package:firebase_messaging/firebase_messaging.dart';

class Ev_FireBase_CallBack
{   FireBase_OnMessage(dynamic message){} }

class Ev_Firebase {
  static List<Ev_FireBase_CallBack> callbacklist = List<Ev_FireBase_CallBack>();
  static String token = "";

  static Future connect(String topic) async {
    print("Firebasd Connect");
    await Firebase.initializeApp();
    if (Platform.isIOS) iOS_Permission();

    Ev_Firebase.token = await  FirebaseMessaging.instance.getToken();
    print("Firebasd Connect token:" + token.toString());

    FirebaseMessaging.onMessage.listen((RemoteMessage message)
    { if(callbacklist.last != null)
    {  print("call fcm callback");
    callbacklist.last.FireBase_OnMessage(message.data);
    }
    });

    FirebaseMessaging.instance.subscribeToTopic(topic);
  }

  static void initState_CallBack(Ev_FireBase_CallBack callback)
  {  print("Add Fcm Callback $callback");
  callbacklist.add(callback); }

  static void set_topic(String topic)
  {  FirebaseMessaging.instance.subscribeToTopic(topic); }

  static void dispose(Ev_FireBase_CallBack callback)
  { callbacklist.remove(callback); }

  static void iOS_Permission() {
    FirebaseMessaging.instance.requestPermission(
      alert: true,
      announcement: false,
      badge: true,
      carPlay: false,
      criticalAlert: false,
      provisional: false,
      sound: true,
    );
  }


}


